
package com.asobimo.ASPurchase;

import com.asobimo.ASPurchase.BillingService.RequestPurchase;
import com.asobimo.ASPurchase.BillingService.RestoreTransactions;
import com.asobimo.ASPurchase.Consts.PurchaseState;
import com.asobimo.ASPurchase.Consts.ResponseCode;

import android.app.Activity;
import android.app.PendingIntent;
import android.app.PendingIntent.CanceledException;
import android.content.Intent;
import android.content.IntentSender;
import android.os.Handler;
import java.lang.reflect.Method;

/** }[Pbg̑X|X邽߂̃C^[tF[X
 */
public abstract class PurchaseObserver {
    private final Activity m_Activity;
    private final Handler m_Handler;
    private Method m_StartIntentSender;
    private Object[] m_StartIntentSenderArgs = new Object[5];
    private static final Class[] START_INTENT_SENDER_SIG = new Class[] {
        IntentSender.class, Intent.class, int.class, int.class, int.class
    };

    public PurchaseObserver(Activity activity, Handler handler) {
        m_Activity = activity;
        m_Handler = handler;
        initCompatibilityLayer();
    }

    public abstract void onBillingSupported(boolean supported);

    /** w̃G[A[ULZȂǂ̍ۂɌĂ΂<br>
     *   RESULT_OK@: I[_[T[o[ɑMꂽ<br>
     *   RESULT_USER_CANCELED : [UACe𔃂Ȃ<br>
     *   RESULT_SERVICE_UNAVAILABLE : }[PbgɐڑłȂ<br>
     *   RESULT_BILLING_UNAVAILABLE : AvwT|[gĂȂi}[PbgAvÂȂǁj<br>
     *   RESULT_ITEM_UNAVAILABLE : J^OɍwACeȂ<br>
     *   RESULT_ERROR ̃G[
     */
    public abstract void onRequestPurchaseResponse(RequestPurchase request, ResponseCode responseCode);

    /** ACewA߂ALZ̍ۂɌĂ΂B
     * @param purchaseTime (1970N11)X^[g̍wBPʂmilliseconds
     */
    public abstract void onPurchaseStateChange(PurchaseState purchaseState, String itemId, long purchaseTime, String developerPayload);

    public abstract void onRestoreTransactionsResponse(RestoreTransactions request, ResponseCode responseCode);

    private void initCompatibilityLayer() {
        try {
            m_StartIntentSender = m_Activity.getClass().getMethod("startIntentSender", START_INTENT_SENDER_SIG);
        } catch (SecurityException e) {
            m_StartIntentSender = null;
        } catch (NoSuchMethodException e) {
            m_StartIntentSender = null;
        }
    }

    void startBuyPageActivity(PendingIntent pendingIntent, Intent intent) {
        if (m_StartIntentSender != null) {
            try {
                // This implements the method call:
                // mActivity.startIntentSender(pendingIntent.getIntentSender(),
                //     intent, 0, 0, 0);
                m_StartIntentSenderArgs[0] = pendingIntent.getIntentSender();
                m_StartIntentSenderArgs[1] = intent;
                m_StartIntentSenderArgs[2] = Integer.valueOf(0);
                m_StartIntentSenderArgs[3] = Integer.valueOf(0);
                m_StartIntentSenderArgs[4] = Integer.valueOf(0);
                m_StartIntentSender.invoke(m_Activity, m_StartIntentSenderArgs);
            } catch (Exception e) {
                //Log.e(TAG, "error starting activity", e);
            }
        } else {
            // Android1.6
            try {
                pendingIntent.send(m_Activity, 0 /* code */, intent);
            } catch (CanceledException e) {
                //Log.e(TAG, "error starting activity", e);
            }
        }
    }

    void postPurchaseStateChange(final PurchaseState purchaseState, final String itemId, final long purchaseTime, final String developerPayload) {
        m_Handler.post(new Runnable() {
            public void run() {
                onPurchaseStateChange(purchaseState, itemId, purchaseTime, developerPayload);
            }
        });
    }
}
