
package com.asobimo.ASPurchase;

import com.asobimo.ASPurchase.BillingService.RequestPurchase;
import com.asobimo.ASPurchase.BillingService.RestoreTransactions;
import com.asobimo.ASPurchase.Consts.PurchaseState;
import com.asobimo.ASPurchase.Consts.ResponseCode;

import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;

/** }[Pbg̒ʐMNX
 */
public class ResponseHandler {
    /** UI\p
     */
    private static PurchaseObserver sPurchaseObserver;

    /** UIXVǗpPurchaseObservero^
     */
    public static synchronized void register(PurchaseObserver observer) {
        sPurchaseObserver = observer;
    }

    /** UIXVǗpPurchaseObserver̓o^
     */
    public static synchronized void unregister(PurchaseObserver observer) {
        sPurchaseObserver = null;
    }

    /** CHECK_BILLING_SUPPORTEĎʂL^
     * @param supported p\Ȃtrue
     */
    public static void checkBillingSupportedResponse(boolean supported) {
        if (sPurchaseObserver != null) {
            sPurchaseObserver.onBillingSupported(supported);
        }
    }

    /** wʂ̃ANeBreBN
     */
    public static void buyPageIntentResponse(PendingIntent pendingIntent, Intent intent) {
        if (sPurchaseObserver == null) {
            return;
        }
        sPurchaseObserver.startBuyPageActivity(pendingIntent, intent);
    }

    /**@PURCHASE_STATE_CHANGEDM̏
     * @param purchaseState (PURCHASED, CANCELED, or REFUNDED)
     * @param productId ACe̍wID
     * @param purchaseTime (Jan 1, 1970)X^[g̓
     */
    public static void purchaseResponse(
            final Context context, final PurchaseState purchaseState, final String productId,
            final String orderId, final long purchaseTime, final String developerPayload) {

        // Update the database with the purchase state. We shouldn't do that
        // from the main thread so we do the work in a background thread.
        // We don't update the UI here. We will update the UI after we update
        // the database because we need to read and update the current quantity
        // first.
        new Thread(new Runnable() {
            public void run() {
//                PurchaseDatabase db = new PurchaseDatabase(context);
//                int quantity = db.updatePurchase(orderId, productId, purchaseState, purchaseTime, developerPayload);
//                db.close();

                // This needs to be synchronized because the UI thread can change the
                // value of sPurchaseObserver.
                synchronized(ResponseHandler.class) {
                    if (sPurchaseObserver != null) {
                        sPurchaseObserver.postPurchaseStateChange(purchaseState, productId, purchaseTime, developerPayload);
                    }
                }
            }
        }).start();
    }

    /**
     * This is called when we receive a response code from Android Market for a
     * RequestPurchase request that we made.  This is used for reporting various
     * errors and also for acknowledging that an order was sent successfully to
     * the server. This is NOT used for any purchase state changes. All
     * purchase state changes are received in the {@link BillingReceiver} and
     * are handled in {@link Security#verifyPurchase(String, String)}.
     * @param context the context
     * @param request the RequestPurchase request for which we received a
     *     response code
     * @param responseCode a response code from Market to indicate the state
     * of the request
     */
    public static void responseCodeReceived(Context context, RequestPurchase request,
            ResponseCode responseCode) {
        if (sPurchaseObserver != null) {
            sPurchaseObserver.onRequestPurchaseResponse(request, responseCode);
        }
    }

    /**
     * This is called when we receive a response code from Android Market for a
     * RestoreTransactions request.
     * @param context the context
     * @param request the RestoreTransactions request for which we received a
     *     response code
     * @param responseCode a response code from Market to indicate the state
     *     of the request
     */
    public static void responseCodeReceived(Context context, RestoreTransactions request,
            ResponseCode responseCode) {
        if (sPurchaseObserver != null) {
            sPurchaseObserver.onRestoreTransactionsResponse(request, responseCode);
        }
    }
}
